#include <iostream>

using namespace std ;

struct TACKE
{
    
    int x1 = 2001 ; int y1 = 2001 ; int x2 = 0 ; int y2 = 0 ;
    
} ;

int main ( ) 
{
    
    int N , K , Pogodni = 0 , FaktorPogodnosti = 0 , OcekivaniFaktorPogodnosti = 0 ;
    
    cin >> N >> K ;
    
    int Farma [ N ] [ N ] ;
    
    for ( int k = 0 ; k < N ; k++ )
    {
        
        for ( int p = 0 ; p < N ; p++ )
        {
        
            cin >> Farma [ k ] [ p ] ;
        
        }
        
    }
    
    TACKE NajNam [ K + 1 ] ;
    
    for ( int k = 1 ; k <= K ; k++ )
    {
        
        for ( int g = 0 ; g < N ; g++ )
        {
        
            for ( int p = 0 ; p < N ; p++ )
            {
        
                if ( Farma [ g ] [ p ] == k )
                {
                    
                    if ( g < NajNam [ k ] . x1 )
                    {
                        
                        NajNam [ k ] . x1 = g ;
                        
                    }
                    
                    else if ( g > NajNam [ k ] . x2 )
                    {
                        
                        NajNam [ k ] . x2 = g ;
                        
                    }
                    
                    if ( p < NajNam [ k ] . y1 )
                    {
                        
                        NajNam [ k ] . y1 = p ;
                        
                    }
                    
                    else if ( p > NajNam [ k ] . y2 )
                    {
                        
                        NajNam [ k ] . y2 = p ;
                        
                    }
                    
                }
                
                else
                {
                    
                }
        
            }
            
            OcekivaniFaktorPogodnosti = ( NajNam [ k ] . x2 - NajNam [ k ] . x1 ) * ( NajNam [ k ] . y2 - NajNam [ k ] . y1 ) ;
        
        for ( int g = 0 ; g < NajNam [ k ] . x2 - NajNam [ k ] . x1 ; g++ )
        {
            
            for ( int p = 0 ; p < NajNam [ k ] . y2 - NajNam [ k ] . y1 ; p++ )
            {
                
                if ( Farma [ NajNam [ k ] . y1 + p ] [ NajNam [ k ] . x1 + g ] == k ) 
                {
                    
                    FaktorPogodnosti++ ;
                    
                }
                
                else
                {
                    
                }
                
            }
            
        }
        
        }
        
    
        
        if ( OcekivaniFaktorPogodnosti == FaktorPogodnosti )
        {
            
            Pogodni++ ;
            
        }
        
    }
    
    /*
    
    5 10
3 2 2 1 4
3 2 2 7 4
8 2 2 1 3
8 8 9 9 9
8 8 1 5 1
    */
    cout << Pogodni ;
    
    
    
}